## clblas 2.8

=== src/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################

cmake_minimum_required(VERSION 2.8)

#User toggle-able options that can be changed on the command line with -D
option( BUILD_RUNTIME "Build the BLAS runtime library" ON )
option( BUILD_TEST "Build the library testing suite (dependency on google test, Boost, and ACML)" ON )
option( BUILD_PERFORMANCE "Copy the performance scripts that can measure and graph performance" OFF )
option( BUILD_SAMPLE "Build the sample programs" OFF )
option( BUILD_CLIENT "Build a command line clBLAS client program with a variety of configurable parameters (dependency on Boost)" OFF )
option( BUILD_KTEST "A command line tool for testing single clBLAS kernel" ON )
option( BUILD_SHARED_LIBS "Build shared libraries" ON )

#enable or disable offline compilation for different devices. Currently only Hawaii, Bonaire, Tahiti have the option.
#option( OPENCL_OFFLINE_BUILD_HAWAII_KERNEL "Offline compile the OpenCL kernels for Hawaii device" OFF)
#option( OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL "Offline compile the OpenCL kernels for Bonaire device" OFF)
#option( OPENCL_OFFLINE_BUILD_TAHITI_KERNEL "Offline compile the OpenCL kernels for Tathit device" OFF)
set( OPENCL_OFFLINE_BUILD_HAWAII_KERNEL OFF)
set( OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL OFF)
set( OPENCL_OFFLINE_BUILD_TAHITI_KERNEL OFF)

#if( (OPENCL_OFFLINE_BUILD_HAWAII_KERNEL AND OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL) OR (OPENCL_OFFLINE_BUILD_HAWAII_KERNEL AND OPENCL_OFFLINE_BUILD_TAHITI_KERNEL) OR (OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL AND OPENCL_OFFLINE_BUILD_TAHITI_KERNEL))
#   MESSAGE( WARNING "More than one device is chosen for offline compilation of static kernels. This might result in running out of heap memory with certain driver. Please consider offline compliation for ONE device only." )
#endif( )

#if( NOT OPENCL_OFFLINE_BUILD_HAWAII_KERNEL )
  #use dynamic generated kernels
#  MESSAGE(STATUS "Build dynamic Hawaii kernels.")
#  MESSAGE(STATUS "Check OPENCL_OFFLINE_BUILD_HAWAII_KERNEL to build kernls at compile-time. This will eliminates clBuildProgram() overhead and better kernel performance with certain driver.")
  add_definitions(-DCLBLAS_HAWAII_DYNAMIC_KERNEL) 
#else()
#  MESSAGE(STATUS "Build static Hawaii kernels.")
#  MESSAGE(STATUS "Uncheck OPENCL_OFFLINE_BUILD_HAWAII_KERNEL to build kernls at run-time")
#  MESSAGE(STATUS "Please ensure the presence of Hawaii device in the system. With certain driver/compiler flags, this might result in compile-time error.")  
#endif( )

#if( NOT OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL )
  #use dynamic generated kernels
#  MESSAGE(STATUS "Build dynamic Bonaire kernels.")
#  MESSAGE(STATUS "Check OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL to build kernls at compile-time. This will eliminates clBuildProgram() overhead and better kernel performance with certain driver.")
  add_definitions(-DCLBLAS_BONAIRE_DYNAMIC_KERNEL) 
#else()
#  MESSAGE(STATUS "Build static Bonaire kernels.")
#  MESSAGE(STATUS "Uncheck OPENCL_OFFLINE_BUILD_BONAIRE_KERNEL to build kernls at run-time")
#  MESSAGE(STATUS "Please ensure the presence of Bonaire device in the system. With certain driver/compiler flags, this might result in compile-time error.")    
#endif( )

#if( NOT OPENCL_OFFLINE_BUILD_TAHITI_KERNEL )
  #use dynamic generated kernels
#  MESSAGE(STATUS "Build dynamic Tahiti kernels.")
#  MESSAGE(STATUS "Check OPENCL_OFFLINE_BUILD_TAHITI_KERNEL to build kernls at compile-time. This will eliminates clBuildProgram() overhead and better kernel performance with certain driver.")
  add_definitions(-DCLBLAS_TAHITI_DYNAMIC_KERNEL) 
#else( )
#  MESSAGE(STATUS "Build static Tahiti kernels.")
#  MESSAGE(STATUS "Uncheck OPENCL_OFFLINE_BUILD_TAHITI_KERNEL to build kernls at run-time")
#  MESSAGE(STATUS "Please ensure the presence of Tahiti device in the system. With certain driver/compiler flags, this might result in compile-time error.")    
#endif( )


# Ask the user to verify compiler version. If OpenCL 2.0 is supported. Certain public flags can be user
set( OPENCL_VERSION "1.2" CACHE STRING "The version of OpenCL supported by your driver/device" )
set_property( CACHE OPENCL_VERSION PROPERTY STRINGS 2.0 1.2 1.1 )
message( STATUS "You have confirmed OpenCL ${OPENCL_VERSION} is supported in your system" )

# By default test-correctness is linked and tested against ACML library.
# However, test-correctness can instead use NETLIB as a reference library
# On Mac OSX systems, this must be set to OFF for the build to succeed (due to nesting of FindBLAS code)
if ( APPLE )
	set(CORR_TEST_WITH_ACML OFF CACHE BOOL "Use ACML library in correctness tests")
else ( )
	message(STATUS "CORR_TEST_WITH_ACML set to ON")
	set(CORR_TEST_WITH_ACML ON CACHE BOOL "Use ACML library in correctness tests")
endif( )

if( CMAKE_GENERATOR MATCHES "NMake" )
  option( NMAKE_COMPILE_VERBOSE "Print compile and link strings to the console" OFF )
  if( NMAKE_COMPILE_VERBOSE )
    set( CMAKE_START_TEMP_FILE "" )
    set( CMAKE_END_TEMP_FILE "" )
    set( CMAKE_VERBOSE_MAKEFILE 1 )
  endif( )
endif( )

# If we are on linux, and we wish to link with the netlib BLAS implementation, we need to have a valid fortran compiler
if( NOT CORR_TEST_WITH_ACML AND NOT WIN32 AND NOT APPLE )
  project(clBLAS Fortran C CXX )
else( )
  project(clBLAS C CXX)
endif( )

# Define a version for the code
if( NOT DEFINED clBLAS_VERSION_MAJOR )
    set( clBLAS_VERSION_MAJOR 2 )
endif( )

if( NOT DEFINED clBLAS_VERSION_MINOR )
    set( clBLAS_VERSION_MINOR 8 )
endif( )

if( NOT DEFINED clBLAS_VERSION_PATCH )
    set( clBLAS_VERSION_PATCH 0 )
endif( )

set( clBLAS_VERSION "${clBLAS_VERSION_MAJOR}.${clBLAS_VERSION_MINOR}.${clBLAS_VERSION_PATCH}")

# Increment this if we break backward compatibility.
set( clBLAS_SOVERSION 2 )

# We have custom written Find* modules now in the root source directory
set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR} )

# On windows, it's convenient to change the default install prefix such that it does NOT point to 'program files' (permissions problems)
# Need to check out CMAKE_RUNTIME_OUTPUT_DIRECTORY variable, and see if that eliminates the need to modify install path
if( WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
	set( CMAKE_INSTALL_PREFIX "${PROJECT_BINARY_DIR}/package" CACHE PATH "Install path prefix, prepended onto install directories" FORCE )
endif( )

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif()

# These variables are meant to contain string which should be appended to the installation paths 
# of library and executable binaries, respectively.  They are meant to be user configurable/overridable.  
set( SUFFIX_LIB_DEFAULT "" )
set( SUFFIX_BIN_DEFAULT "" )

if(TARGET_PLATFORM EQUAL 32 OR TARGET_PLATFORM EQUAL 64)
    set(TARGET_PLATFORM ${TARGET_PLATFORM} CACHE STRING "Target platform type (32-bit or 64-bit)" FORCE)
else()
    if(CMAKE_SIZEOF_VOID_P MATCHES 8)
        set(TARGET_PLATFORM "64" CACHE STRING "Target platform type (32-bit or 64-bit)" FORCE)
    else()
        set(TARGET_PLATFORM "32" CACHE STRING "Target platform type (32-bit or 64-bit)" FORCE)
    endif()
endif()

message(STATUS "Target platform: ${TARGET_PLATFORM}-bit")
if(TARGET_PLATFORM EQUAL 32)
    set(_arch "x86" INTERNAL)
    set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS FALSE)
else()
    set(_arch "x86_64" INTERNAL)
    set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)
    if( NOT APPLE )
        set( SUFFIX_LIB_DEFAULT "64" )
    endif( )
endif()

set( SUFFIX_LIB ${SUFFIX_LIB_DEFAULT} CACHE STRING "String to append to 'lib' install path" )
set( SUFFIX_BIN ${SUFFIX_BIN_DEFAULT} CACHE STRING "String to append to 'bin' install path" )

if( MSVC_IDE )
    set_property( GLOBAL PROPERTY USE_FOLDERS TRUE )
endif( )

# add the math library for Linux
if( UNIX ) 
    set(MATH_LIBRARY "m")
endif()

# set the path to specific OpenCL compiler
set( OPENCL_COMPILER_DIR "OPENCL COMPILER PATH" CACHE PATH "OPENCL COMPILER PATH")
if ( ${OPENCL_COMPILER_DIR} STREQUAL "OPENCL COMPILER PATH")
    message( STATUS "Using default OpenCL Compiler")
	  set(ENV_PATH "$ENV{PATH}")
else ()
    message( STATUS "OPENCL COMPILER: ${OPENCL_COMPILER_DIR}")
	if(UNIX)
	  set(ENV_PATH "${OPENCL_COMPILER_DIR}")
	else()
	  set(ENV_PATH "${OPENCL_COMPILER_DIR}")
	endif()
endif()

# Find the BLAS library
# TODO: maybe this could be written using the FindBLAS module in the future
if( BUILD_TEST )
	if(NOT CORR_TEST_WITH_ACML)
	    if(APPLE)
			find_library(BLAS_LIBRARIES Accelerate HINTS /System/Library/Frameworks/Accelerate.framework)
		       	MARK_AS_ADVANCED(BLAS_LIBRARIES)
		       	message(STATUS "Using Accelerate framework on Mac OS-X")
	    else()
			find_package( Netlib COMPONENTS BLAS REQUIRED )
        endif()
		else( )
		# Find ACML BLAS implementation
		# platform dependent ACML subdirectory
		if (WIN32)
			set(ACML_SUBDIR ifort${TARGET_PLATFORM}_mp)
		else()
		   set(ACML_SUBDIR gfortran${TARGET_PLATFORM}_mp)
		endif()

		find_path(ACML_INCLUDE_DIRS acml.h
			HINTS
				${ACML_ROOT}/include
				${ACML_ROOT}/${ACML_SUBDIR}/include
				$ENV{ACML_ROOT}/include
                                $ENV{ACML_ROOT}/${ACML_SUBDIR}/include
		)

		if( ACML_INCLUDE_DIRS )
		else()
			message(WARNING "Cannot find acml.h")
		endif()
		
		if( UNIX )
			find_library(ACML_LIBRARIES acml_mp
				HINTS
					${ACML_ROOT}/lib
					${ACML_ROOT}/${ACML_SUBDIR}/lib
					$ENV{ACML_ROOT}/lib
                                        $ENV{ACML_ROOT}/${ACML_SUBDIR}/lib
			)
			find_library(_acml_mv_library acml_mv
				HINTS
					${ACML_ROOT}/lib
					${ACML_ROOT}/${ACML_SUBDIR}/lib
					$ENV{ACML_ROOT}/lib
                                        $ENV{ACML_ROOT}/${ACML_SUBDIR}/lib
			)
			mark_as_advanced(_acml_mv_library)
		endif( )
		
		if(WIN32)
			find_library(ACML_LIBRARIES libacml_mp_dll
				HINTS
					${ACML_ROOT}/lib
					${ACML_ROOT}/${ACML_SUBDIR}/lib
					$ENV{ACML_ROOT}/lib
                                        $ENV{ACML_ROOT}/${ACML_SUBDIR}/lib
			)
		endif( )
		
		if( NOT ACML_LIBRARIES )
			message(WARNING "Cannot find libacml")
		endif( )

		if(ACML_INCLUDE_DIRS AND ACML_LIBRARIES)
			if(_acml_mv_library)
				list(APPEND ACML_LIBRARIES ${_acml_mv_library})
			endif()
			message(STATUS "Found ACML: ${ACML_LIBRARIES}")
			set(ACML_FOUND TRUE BOOL "Found the ACML package")
		endif()
		mark_as_advanced(ACML_FOUND ACML_INCLUDE_DIRS ACML_LIBRARIES)

	endif( )
endif( )

# This will define OPENCL_FOUND
find_package( OpenCL )

# Find Boost on the system, and configure the type of boost build we want
set( Boost_USE_MULTITHREADED ON )
set( Boost_USE_STATIC_LIBS   ON )
set( Boost_DETAILED_FAILURE_MSG   ON )
set( Boost_DEBUG ON )
set( Boost_ADDITIONAL_VERSIONS "1.44.0" "1.44" "1.47.0" "1.47" )

find_package( Boost 1.33.0 COMPONENTS program_options )
message(STATUS "Boost_PROGRAM_OPTIONS_LIBRARY: ${Boost_PROGRAM_OPTIONS_LIBRARY}")


if( NOT Boost_FOUND )
	message( STATUS "The clBLAS ktest requires boost to be installed" )
	set( BUILD_KTEST OFF )
	message( STATUS "The clBLAS client requires boost to be installed" )
	set( BUILD_CLIENT OFF )
endif()

# Turn on maximum compiler verbosity
if(CMAKE_COMPILER_IS_GNUCXX)

=== src/library/CMakeLists.txt ===
# ########################################################################
# Copyright 2013 Advanced Micro Devices, Inc.
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ########################################################################




################################################################################
# AutoGemm Begin
################################################################################

# AutoGemm scripts and out files
set(AUTOGEMM_SCRIPTS
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemm.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemmParameters.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/Common.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/Includes.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelOpenCL.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelParameters.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelSelection.py
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelsToPreCompile.py
)
set(AUTOGEMM_HEADERS
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmClKernels.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBuildOptionsBinary.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBinaries.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSelection.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSelectionSpecific.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBuildOptionsSource.h
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSources.h
)

set(AUTOGEMM_SRC
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmClKernels.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBuildOptionsBinary.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBinaries.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSelection.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSelectionSpecific.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelBuildOptionsSource.cpp
  ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelSources.cpp
)

#set(USERGEMM_SRC
#  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/UserGemmKernelSources/UserGemmKernelSourceIncludes.cpp
#)

set(USERGEMM_HEADERS
   ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/UserGemmKernelSources/UserGemmKernelSourceIncludes.h
   ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/UserGemmKernelSources/UserGemmClKernels.h
)

set(AUTOGEMM_TEST_SRC
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemmTools/TestAutoGemm.cpp
)
set(AUTOGEMM_PROFILER_SRC
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemmTools/ProfileAutoGemm.cpp
)
set(AUTOGEMM_PRECOMPILE_SRC
  ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemmTools/AutoGemmPreCompileKernels.cpp
)
set( AUTOGEMM_PRECOMPILED_KERNELS
  ${CMAKE_BINARY_DIR}/include/AutoGemmKernelBinaries/AutoGemmKernelBinariesPreCompiled.h
)

# AutoGemm options for pre-compiling kernels
option( PRECOMPILE_GEMM_PRECISION_SGEMM "AutoGemm: pre-compile sgemm kernels" OFF)
option( PRECOMPILE_GEMM_PRECISION_DGEMM "AutoGemm: pre-compile dgemm kernels" OFF)
option( PRECOMPILE_GEMM_PRECISION_CGEMM "AutoGemm: pre-compile cgemm kernels" OFF)
option( PRECOMPILE_GEMM_PRECISION_ZGEMM "AutoGemm: pre-compile zgemm kernels" OFF)

option( PRECOMPILE_GEMM_TRANS_NN "AutoGemm: pre-compile NN transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_NT "AutoGemm: pre-compile NT transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_NC "AutoGemm: pre-compile NC transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_TN "AutoGemm: pre-compile TN transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_TT "AutoGemm: pre-compile TT transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_TC "AutoGemm: pre-compile TC transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_CN "AutoGemm: pre-compile CN transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_CT "AutoGemm: pre-compile CT transpose cases" OFF)
option( PRECOMPILE_GEMM_TRANS_CC "AutoGemm: pre-compile CC transpose cases" OFF)


# opencl compiler version
#set( PRECOMPILE_GEMM_OPENCL_VERSION "2.0" CACHE STRING "OpenCL compiler version supported by device driver." )
#set_property( CACHE PRECOMPILE_GEMM_OPENCL_VERSION PROPERTY STRINGS 2.0 1.2 1.1 )
#message( STATUS "AutoGemm PreCompiler will use OpenCL ${PRECOMPILE_GEMM_OPENCL_VERSION} compiler." ) 

# PreCompile precision selected?
set( PRECOMPILE_GEMM_PRECISION_SELECTED OFF)
if (   PRECOMPILE_GEMM_PRECISION_SGEMM
    OR PRECOMPILE_GEMM_PRECISION_DGEMM
    OR PRECOMPILE_GEMM_PRECISION_CGEMM
    OR PRECOMPILE_GEMM_PRECISION_ZGEMM )
  set( PRECOMPILE_GEMM_PRECISION_SELECTED ON)
endif()

# PreCompile transpose selected?
set( PRECOMPILE_GEMM_TRANS_SELECTED OFF)
if (   PRECOMPILE_GEMM_TRANS_NN
    OR PRECOMPILE_GEMM_TRANS_NT
    OR PRECOMPILE_GEMM_TRANS_NC
    OR PRECOMPILE_GEMM_TRANS_TN
    OR PRECOMPILE_GEMM_TRANS_TT
    OR PRECOMPILE_GEMM_TRANS_TC
    OR PRECOMPILE_GEMM_TRANS_CN
    OR PRECOMPILE_GEMM_TRANS_CT
    OR PRECOMPILE_GEMM_TRANS_CC )
  set( PRECOMPILE_GEMM_TRANS_SELECTED ON)
endif()

# PreCompile is valid and active?
set( PRECOMPILE_GEMM_ACTIVE OFF)
if ( PRECOMPILE_GEMM_PRECISION_SELECTED
    AND PRECOMPILE_GEMM_TRANS_SELECTED)
  # valid selection
  set( PRECOMPILE_GEMM_ACTIVE ON)
  MESSAGE( STATUS "AutoGemm-PreCompile: selected kernels will be pre-compiled." )
elseif(NOT PRECOMPILE_GEMM_PRECISION_SELECTED
    AND NOT PRECOMPILE_GEMM_TRANS_SELECTED)
  MESSAGE( STATUS "AutoGemm-PreCompile: no kernels to be pre-compiled." )
else()
  MESSAGE( SEND_ERROR "AutoGemm-PreCompile: To pre-compile gemm kernels, select at lease one option from each of PRECOMPILE_GEMM_PRECISION_* and PRECOMPILE_GEMM_TRANS_*; otherwise, unselect all PRECOMPILE_GEMM_* options to not pre-compile any gemm kernels." )
endif()

# build commandline argument for AutoGemm
set( AGPC_ARGS --output ${CMAKE_BINARY_DIR}/include )

if ( PRECOMPILE_GEMM_ACTIVE )
  # precisions
  set(AGPC_ARGS ${AGPC_ARGS} --precisions )
  if (PRECOMPILE_GEMM_PRECISION_SGEMM)
    set(AGPC_ARGS ${AGPC_ARGS} s )
  endif()
  if (PRECOMPILE_GEMM_PRECISION_DGEMM)
    set(AGPC_ARGS ${AGPC_ARGS} d )
  endif()
  if (PRECOMPILE_GEMM_PRECISION_CGEMM)
    set(AGPC_ARGS ${AGPC_ARGS} c )
  endif()
  if (PRECOMPILE_GEMM_PRECISION_ZGEMM)
    set(AGPC_ARGS ${AGPC_ARGS} z )
  endif()

  # orders
  set(AGPC_ARGS ${AGPC_ARGS} --orders clblasColumnMajor )

  # transposes
  set(AGPC_ARGS ${AGPC_ARGS} --transposes )
  if (PRECOMPILE_GEMM_TRANS_NN)
    set(AGPC_ARGS ${AGPC_ARGS} NN )
  endif()
  if (PRECOMPILE_GEMM_TRANS_NT)
    set(AGPC_ARGS ${AGPC_ARGS} NT )
  endif()
  if (PRECOMPILE_GEMM_TRANS_NC)
    set(AGPC_ARGS ${AGPC_ARGS} NC )
  endif()
  if (PRECOMPILE_GEMM_TRANS_TN)
    set(AGPC_ARGS ${AGPC_ARGS} TN )
  endif()
  if (PRECOMPILE_GEMM_TRANS_TT)
    set(AGPC_ARGS ${AGPC_ARGS} TT )
  endif()
  if (PRECOMPILE_GEMM_TRANS_TC)
    set(AGPC_ARGS ${AGPC_ARGS} TC )
  endif()
  if (PRECOMPILE_GEMM_TRANS_CN)
    set(AGPC_ARGS ${AGPC_ARGS} CN )
  endif()
  if (PRECOMPILE_GEMM_TRANS_CT)
    set(AGPC_ARGS ${AGPC_ARGS} CT )
  endif()
  if (PRECOMPILE_GEMM_TRANS_CC)
    set(AGPC_ARGS ${AGPC_ARGS} CC )
  endif()

  # betas
  set(AGPC_ARGS ${AGPC_ARGS} --betas 0 1 )



################################################################################
# add target for generating pre-compile WhichKernels header
################################################################################
set( AUTOGEMM_PRECOMPILE_HEADER_SRC ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelsToPreCompile.py )
set( AUTOGEMM_PRECOMPILE_HEADER_OUT ${CMAKE_BINARY_DIR}/include/AutoGemmIncludes/AutoGemmKernelsToPreCompile.h )
add_custom_command(
  OUTPUT ${AUTOGEMM_PRECOMPILE_HEADER_OUT}
  COMMAND python ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/KernelsToPreCompile.py ${AGPC_ARGS}
  DEPENDS ${AUTOGEMM_PRECOMPILE_HEADER_SRC}
)

################################################################################
# add target for compiling pre-compile executable
################################################################################
add_executable(AutoGemm_PreCompile_Bin
  ${AUTOGEMM_PRECOMPILE_SRC}
  ${AUTOGEMM_PRECOMPILE_HEADER_OUT}
  ${AUTOGEMM_HEADERS}
  ${AUTOGEMM_SRC}
  ${AUTOGEMM_SCRIPTS}
  )
target_link_libraries(AutoGemm_PreCompile_Bin ${OPENCL_LIBRARIES})
set_property( TARGET AutoGemm_PreCompile_Bin PROPERTY FOLDER "AutoGemm")
#set_target_properties(
  #AutoGemm_PreCompile_Bin
  #PROPERTIES
  #EXCLUDE_FROM_ALL TRUE
  #EXCLUDE_FROM_DEFAULT_BUILD TRUE
#)


################################################################################
# add target for running pre-compile executable
################################################################################
add_custom_command(
  OUTPUT ${AUTOGEMM_PRECOMPILED_KERNELS}
  COMMAND AutoGemm_PreCompile_Bin ${CMAKE_BINARY_DIR}
  DEPENDS AutoGemm_PreCompile_Bin
)

endif()#endif precompile active


################################################################################
# add target for main AutoGemm headers / source
################################################################################
add_custom_command(
  OUTPUT ${AUTOGEMM_HEADERS} ${AUTOGEMM_SRC}
  COMMAND python ${CMAKE_SOURCE_DIR}/library/blas/AutoGemm/AutoGemm.py --output-path ${CMAKE_BINARY_DIR}/include --opencl-compiler-version ${OPENCL_VERSION}
  DEPENDS ${AUTOGEMM_SCRIPTS}
)


include_directories(
    ${OPENCL_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}/include
    .
)

################################################################################
# AutoGemm Tools
################################################################################
add_executable(AutoGemm_Tools_Test
  ${AUTOGEMM_TEST_SRC}
  ${AUTOGEMM_SRC}
  ${AUTOGEMM_HEADERS}
  ${AUTOGEMM_SCRIPTS}
  )
target_link_libraries(AutoGemm_Tools_Test ${OPENCL_LIBRARIES})
set_property( TARGET AutoGemm_Tools_Test PROPERTY FOLDER "AutoGemm")
set_target_properties(
  AutoGemm_Tools_Test
  PROPERTIES
  EXCLUDE_FROM_ALL TRUE
  EXCLUDE_FROM_DEFAULT_BUILD TRUE
)


add_executable(AutoGemm_Tools_Profile
  ${AUTOGEMM_PROFILER_SRC}
  ${AUTOGEMM_SRC}
  ${AUTOGEMM_HEADERS}
  ${AUTOGEMM_SCRIPTS}
  )
target_link_libraries(AutoGemm_Tools_Profile ${OPENCL_LIBRARIES})
set_property( TARGET AutoGemm_Tools_Profile PROPERTY FOLDER "AutoGemm")
set_target_properties(
  AutoGemm_Tools_Profile
  PROPERTIES
  EXCLUDE_FROM_ALL TRUE
  EXCLUDE_FROM_DEFAULT_BUILD TRUE
)

source_group(AutoGemm\\scripts FILES ${AUTOGEMM_SCRIPTS} )
source_group(AutoGemm\\include FILES ${AUTOGEMM_HEADERS} )
source_group(AutoGemm\\src FILES ${AUTOGEMM_SRC} ${AUTOGEMM_PRECOMPILED_KERNELS} )

################################################################################
# AutoGemm End
################################################################################

################################################################################
# BEGIN Pre Compile General (static) Kernels
################################################################################
# options for pre-compiling trsm kernels
option( PRECOMPILE_TRSM_STRSM "pre-compile available dtrsm kernels" OFF )
option( PRECOMPILE_TRSM_DTRSM "pre-compile available strsm kernels" OFF )
if(PRECOMPILE_TRSM_DTRSM)
add_definitions(-DCLBLAS_OFFLINE_COMPILE_DTRSM)
message(STATUS "precompile DTRSM kernels.")
endif()
if(PRECOMPILE_TRSM_STRSM)
add_definitions(-DCLBLAS_OFFLINE_COMPILE_STRSM)
message(STATUS "precompile STRSM kernels. (not yet implemented)")
endif()


################################################################################

=== debian/changelog ===
clblas (2.8-1) unstable; urgency=medium

  * New upstream release.
  * d/patches:
    - Remove fix-missing-stdlib.patch, applied upstream.
    - Remove debian-enable-multiarch.patch, no longer needed.
    - Refresh disable-multilib-cflags.patch, fix-pthread-linkage.patch
      and use-boost-dynamic-libs.patch.
  * d/rules:
    - use SUFFIX_LIB cmake build option to enable multiarch.
    - add missing call to dh_doxygen.
  * Make build of documentation architecture independent:
    - Move doxygen dependency to Build-Depends-Indep,
    - Move call to doxygen to dh_auto_build-indep,
    - Clear doxygen artefacts in dh_auto_clean-indep.
  * Remove system jquery symlinks in HTML documentation:
    - Remove the install dependency on libjs-query,
    - Remove the .links file for the -doc package.
  * Run `cme fix` on d/control and d/changelog.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 27 Oct 2015 08:10:56 +0000

clblas (2.6-3) unstable; urgency=medium

  * d/rules: fix FTBFS on ppc64el. (Closes: #798024)
  * d/{control,rules}: now follows debmake layout.
  * add README.Debian, explains packaging policy and layout.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 19 Sep 2015 10:30:54 +0100

=== debian/control ===
Source: clblas
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-program-options-dev,
               ocl-icd-opencl-dev | opencl-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clblas.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/clblas.git
Homepage: https://github.com/clMathLibraries/clBLAS

Package: libclblas-bin
Architecture: any
Multi-Arch: foreign
Depends: libclblas2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: OpenCL BLAS library (executables)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS executables.

Package: libclblas-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libclblas2 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libclblas-doc
Description: OpenCL BLAS library (development files)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS development files.

Package: libclblas-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends}
Description: OpenCL BLAS library (documentation)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS documentation.

Package: libclblas2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: OpenCL BLAS library (shared library)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS shared library.

Package: libclblas2-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Depends: libclblas2 (= ${binary:Version}),
         ${misc:Depends}
Description: OpenCL BLAS library (debugging symbols)
 This library provides an implementation of the Basic Linear Algebra 
 Subprograms levels 1, 2 and 3, using OpenCL and optimized for AMD GPU 
 hardware.
 .
 This package provides the clBLAS debugging symbols.

## clblas 2.8+ds1

=== debian/changelog ===
clblas (2.8+ds1-1) unstable; urgency=medium

  * Add non-dfsg repack suffix.
    Reason: trigger a new source tarball upload of v2.8.
  * d/copyright: update year.
  * d/watch: add dversionmangling due to repack.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 28 Oct 2015 19:27:03 +0000

clblas (2.8-2) unstable; urgency=medium

  * Revert involuntary patching of source tree.
  * Fix FTBFS due to missing dependency on Python.
  * d/p: add add-missing-stdlib-include.patch, fixes FTBFS error due to
     missing inclusion of stdlib. 

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 28 Oct 2015 15:44:38 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,8 @@
 Build-Depends: cmake,
                debhelper (>= 9),
                libboost-program-options-dev,
-               ocl-icd-opencl-dev | opencl-dev
+               ocl-icd-opencl-dev | opencl-dev,
+               python
 Build-Depends-Indep: doxygen
 Standards-Version: 3.9.6
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clblas.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Environment information.
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Build without Altivec to prevent FTBFS on ppc64el.
ifeq ($(DEB_HOST_ARCH),ppc64el)
DEB_CFLAGS_MAINT_APPEND += -mno-altivec
endif

%:
	dh $@ --parallel \
		--sourcedirectory=src \
		--dbg-package=libclblas2-dbg

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_RUNTIME=ON \
		-DBUILD_TEST=OFF \
		-DBUILD_PERFORMANCE=OFF \
		-DBUILD_SAMPLE=OFF \
		-DBUILD_CLIENT=ON \
		-DBUILD_KTEST=OFF \
		-DBUILD_SHARED_LIBS=ON \
		-DSUFFIX_LIB=/${DEB_HOST_MULTIARCH}

override_dh_auto_build-indep:
	cd doc && doxygen clBLAS.doxy

override_dh_auto_install-indep:
	# Pass.

override_dh_auto_clean-indep:
	rm -rf doc/html
	rm -f doc/doxygen_sqlite3.db

override_dh_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep
